#ifndef _M_H_
#define _M_H_
#include <iostream>

using namespace std;

//Klasa reprezentujaca macierz kwadratowa A nxn + macierz b nxm dla ukladow Ax=b
template<class T>
class SquareM
{
private:
	T *tA;
	T *tB;
	int *per;
	int n,m;
	int mode;
	enum Mode
	{
		null,
		part,
		full,
		jordan,
		lu1,
		lu2,
		d3,
		cb,
		iter
	};
	T ch_part(int k); //wybor czesciowy od k-tej kolumny
	T ch_full(int k); //wybor pelny od k-tej kolumny

public:

	//FUNKCJE OBSLUGOWE

	SquareM(int n){mode=null; this->n=n; m=1; per=0; tA=new T[n*n]; tB=new T[n];}
	SquareM(int n,int m){mode=null; this->n=n; this->m=m; per=0; tA=new T[n*n]; tB=new T[m*n];}
	~SquareM() {delete []tA; delete []tB; if(per) delete []per;}

	void SetA(T *tab);
	void SetB(T *tab);
	T &A(int i,int j) {return *(tA+(i-1)*n+(j-1));} //konwencja wiersz, kolumna, A(1,1) - pierwszy element.
	T &B(int i,int j) {return *(tB+(i-1)*m+(j-1));}

	friend istream &operator>><T>(istream &s,SquareM<T> &m);
	friend ostream &operator<<<T>(ostream &s,SquareM<T> &m);

	//METODY DOKLADNE

	//z czesciowym wyborem
	int Gauss_partial();

	//z pelnym wyborem
	int Gauss_full();

	//Gaussa-Jordana z pelnym wyborem
	int Gauss_Jordan();

	//Rozklad bezposredni Doolittle'a
	int LU1();

	//Rozklad bezposredni Crouta
	int LU2();

	//Metoda eliminacji Gaussa dla macierzy trojdiagonalnej
	int D3();

	//Metoda Choleskiego-Banachiewicza
	int CB();

	//METODY ITERACYJNE (k-iteracyjne)

	//metoda Richarssona
	int Richardson(int,T=.1);

	//metoda Jacobiego
	int Jacob(int);

	//metoda Gaussa-Seidla
	int GS(int);

	//metoda SOR
	int SOR(int,T=1.);

	//FUNKCJE WYJSCIA

	//wypisuje wyniki ukladu rownan (poprawne, jesli macierz trojkatna)
	void Results(ostream &s);

	//wypisuje rozklad LU macierzy
	void LU(ostream &s);
};

#endif //_M_H_
